#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include "basic.h"


static int n = 10000 ;
static volatile int sum = 0 ;
static volatile int start = 0 ;

void *f(void *p) {
  while (!start) ;
  sum++ ;
  return NULL ;
}

void run_loose(void) {
  int broken = 0 ;
  for (int k = n ; k > 0 ; k--) {
    sum = 0 ;
    start = 0 ;
    pthread_t th1,th2 ;
    create_thread(&th1,f,NULL) ;
    create_thread(&th2,f ,NULL) ;
    start = 1 ;
    (void)join_thread(&th2) ;
    (void)join_thread(&th1) ;
    if (sum != 2) broken++ ;
  }
  printf("Broken:  %i/%i\n",broken,n) ;
}

int main (int argc, char **argv) {
  if (argc > 1) n = atoi(argv[1]) ;
  run_loose() ;
  return 0 ;
}
