#include <pthread.h>
/* Malloc with error checking */
void *malloc_check(size_t sz) ;

/* Threads */
void create_thread(pthread_t *th,void *(*f)(void *),void *x) ;
void create_thread_detached(pthread_t *th,void *(*f)(void *),void *x) ;
void *join_thread(pthread_t *th) ;

/* Mutex */
pthread_mutex_t *alloc_mutex(void) ;
void free_mutex(pthread_mutex_t *p) ;
void lock_mutex(pthread_mutex_t *p) ;
void unlock_mutex(pthread_mutex_t *p) ;

/* Condition variable */
pthread_cond_t *alloc_cond(void) ;
void free_cond(pthread_cond_t *p) ;

void wait_cond(pthread_cond_t *c, pthread_mutex_t *m) ;
void signal_cond(pthread_cond_t *c) ;
void broadcast_cond(pthread_cond_t *c) ;

/* Barrier */
